#ifndef UTILITIEC_RWLOCK_H
#define UTILITIEC_RWLOCK_H

#if defined(__unix__) || (defined(__APPLE__) && defined(__MACH__)) // Fuck you, apple

#include <pthread.h>

typedef pthread_rwlock_t OSRWLock;


#elif defined(_WIN32)
#include <syncapi.h>

typedef PSRWLOCK OSRWLock;

#else
#error "Threading standard not supported"

#endif

int OSRWLock_Create(OSRWLock* target);
void OSRWLock_Destroy(OSRWLock* rwlock);

int OSRWLock_Read(OSRWLock* rwlock);
int OSRWLock_Write(OSRWLock* rwlock);
int OSRWLock_ReleaseRead(OSRWLock* rwlock);
int OSRWLock_ReleaseWrite(OSRWLock* rwlock);

#endif
